<?php
/* FILELIST DIENT DER VEREINFACHUNG DER PFLEGE VON DOWNLOAD-ARCHIVEN
VORAUSSETZUNGEN:
Webspace und PHP-Unterstuetzung (PHP fuer LINUX/UNIX).
INSTALLATION:
****
WICHTIG: Die Datei einfach in ein Verzeichnis >> oberhalb << des Download-Verzeichnisses ablegen.
D.h. Filelist NICHT in demselben Verzeichnis wie die Download-Archive abspeichern.
****
ERLAEUTERUNG:
Die Download-Archive koennen einfach per FTP in das Download-Verzeichnis »download_depot« übertragen
werden - das Download-Verzeichnis kann weitere Verzeichnisse enthalten (Verzeichnis-Tiefe max. 9
- default 3 - mit dem Download-Verzeichnis).
Es koennen Archive hinzugefügt, geloescht oder verschoben werden, die Datei-Liste wird automatisch
aktualisiert durch die PHP-Datei filelist.php.
Das Array $file_type_array fuer die Aufnahme der Dateitypen, die in der Datei-Liste beruecksichtigt
werden, kann beliebig erweitert bzw. gekuerzt werden.
***
NAMENS-SYNTAX der Download-Archive:
Thema_Hier_stehen_die_Erlaeuterungen.Dateiendung
Das 1. Wort vor dem 1. Unterstrich (_) wird fuer das Thema (siehe Titelzeile in der Tabelle) benutzt.
Die weiteren Worte bis zum 1. Punkt (.) werden fuer den Erlaeuterungstext verwendet.

Beispiel: PHP-Programm_FILELIST_-_Pflege_von_Download-Verzeichnisse.zip
Thema: PHP-Programm

Erlaeuterung: FILELIST - Pflege von Download-Verzeichnisse
Die Unterstriche werden von dem PHP-Prgogramm FILELIST durch Leerzeichen ersetzt.

Empfehlung: Fuer die Dateinamen nur das englische Alphabet, Zahlen, Untersriche (_), Bindestriche (-)
und den Punkt verwenden. D.h. auf landestypische Zeichen, Umlaute am besten verzichten.
***
*/
// +++ ANFANG KONFIGURATION +++
$startdir="./download_depot"; // Startverzeichnis fuer die Dateiliste: dies ist der wichtigste Eintrag, alle anderen Eintraege koennen i.d.R. erstmal uebernommen werden
$directory_depth=3; // Verzeichnis-Tiefe: gueltige Werte 1 - 9; default => 3
$table_title_name="Download-Archiv"; // Titel der Tabelle
$table_feet_name="Verzeichnisse:"; // Titel des Tabellenfuszes
$file_type_array=array(".zip", ".tgz", ".gz", ".tar", ".rar", ".7z", ".iso", ".img"); // Dateiendungen der Dateitypen die aufgelistet werden sollen; Dateiendungen bitte in Kleinschreibweise eintragen
$table_colon_name_array=array("Lfd.-Nr.:", "Thema", "Erl&auml;uterung", "letzte &Auml;nderung<br>des Inhaltes", "Dateigr&ouml;&szlig;e", "Download"); // Spaltennamen der Tabelle
// Farben fuer die Tabelle festlegen
$table_color_array=
   array(
           "#B49793", // Farbe des Tabellenrahmen: default => #009E00 (gruen 1)
           "#FFFFFF", // Farbhintergrund des Tabellentitels: default => #FFFFFF (weisz)
           "#000000", // Textfarbe  des Tabellentitels: default => #000000 (schwarz)
           "#B7CDC5", // Farbhintergrund der Spaltentitel: default => #00AEAE (gruen 2)
           "#000000", // Textfarbe  der Spaltentitel: default => #000000 (schwarz)
           "#FFFFFF", // Farbhintergrund des Tabelleninhalts: default => #FFFFFF (weisz)
           "#000000", // Textfarbe  des Tabelleninhalts: default => #000000 (schwarz)
           "#FFFFFF", // Farbhintergrund des Tabellenfuszes: default => #FFFFFF (weisz)
           "#000000" // Textfarbe  des Tabellenfuszes: default => #000000 (schwarz)
        );
// +++ ENDE KONFIGURATION +++
$data_transfer_array=array(); // Array fuer die Datenuebergabe an die Funktion
// Funktion fuer die Erstellung der Download-Tabelle
function list_directory($DataTransferArray) {
   if(!preg_match("/^[1-9]$/",$DataTransferArray[1])) $DataTransferArray[1]=3;
   // Pruefung: Vorhandensein des Download-Verzeichnisses
   if(!file_exists($DataTransferArray[0])) {
      print "<b>ERROR:</b> DIRECTORY <b>" . $DataTransferArray[0] . "</b> NOT FOUND!!";
      exit;
   }
   $ListDirectoryArray=array();
   $DirectoryArray=array();
   $FilenameArray=array();
   $FilenameArraySortTmp=array();
   $FilenameArraySort=array();
   $FilemtimeArray=array();
   $FilesizeArray=array();
   // Einfuegestelle fuer Zusatzfunktion
   array_push($DirectoryArray,$DataTransferArray[0]);
   $DirectoryArrayCount=count($DirectoryArray);
   for($x=0; $x<$DirectoryArrayCount; $x++) {
   $Handle=opendir($DirectoryArray[$x]);
      while($Filename = readdir($Handle)) {
         if($Filename != "." && $Filename != "..") {
            $DirectoryNameLength=strlen($DirectoryArray[$x])-1;
            $LastSlashPositionDirectory=strrpos($DirectoryArray[$x], '/');
            if($DirectoryNameLength == $LastSlashPositionDirectory) {
               $DirectoryArray[$x]=substr($DirectoryArray[$x], 0, -1);
            }
            $Nextfile=$DirectoryArray[$x] . "/" . $Filename;
               if(is_dir($Nextfile) && substr_count($Nextfile, '/') <= $DataTransferArray[1]) {
                 array_push($DirectoryArray,$Nextfile);
                 $DirectoryArrayCount=count($DirectoryArray);
               }
               else
               {
                  $FiletypeNextfile=substr($Nextfile, strrpos($Nextfile, '.'));
                  if(in_array(strtolower($FiletypeNextfile), $DataTransferArray[4])) {
                     array_push($FilenameArray, $Nextfile);
                  } elseif(in_array(strtoupper($FiletypeNextfile), $DataTransferArray[4])) {
                     array_push($FilenameArray, $Nextfile);
                  }
               }
          }
      }
      closedir($Handle);
   }
   $FilenameArrayCount=count($FilenameArray);
   for($y=0; $y<$FilenameArrayCount; $y++) {
      $FilenameArraySortA=explode("/", $FilenameArray[$y]);
      $FilenameArraySortB=array_reverse($FilenameArraySortA);
      $FilenameStringSortB=implode("/", $FilenameArraySortB);
      array_push($FilenameArraySortTmp, $FilenameStringSortB);
      unset($FilenameArraySortA);
      unset($FilenameArraySortB);
      unset($FilenameStringSortB);
   }
   // Flags: SORT_REGULAR (Default-Wert), SORT_NUMERIC, SORT_STRING, SORT_LOCALE_STRING
   sort($FilenameArraySortTmp, SORT_REGULAR);
   $FilenameArraySortTmpCount=count($FilenameArraySortTmp);
   for($z=0; $z<$FilenameArraySortTmpCount; $z++) {
      $FilenameArraySortA=explode("/", $FilenameArraySortTmp[$z]);
      $FilenameArraySortB=array_reverse($FilenameArraySortA);
      $FilenameStringSortB=implode("/", $FilenameArraySortB);
      array_push($FilenameArraySort, $FilenameStringSortB);
      unset($FilenameArraySortA);
      unset($FilenameArraySortB);
      unset($FilenameStringSortB);
   }
   unset($FilenameArraySortTmp);
   $FilenameArraySortCount=count($FilenameArraySort);
   for($u=0; $u<$FilenameArraySortCount; $u++) {
      array_push($FilemtimeArray, date("d.m.Y - H:i:s", filemtime($FilenameArraySort[$u])));
      array_push($FilesizeArray, filesize($FilenameArraySort[$u]));
      // Einfuegestelle fuer Zusatzfunktion
   }
   array_push($ListDirectoryArray,$FilenameArraySort);
   array_push($ListDirectoryArray,$FilemtimeArray);
   array_push($ListDirectoryArray,$FilesizeArray);
   // Einfuegestelle fuer Zusatzfunktion
   $TableContent ="  <table id=\"table_result\">\n";
   $TableContent .="    <tr>\n";
   $TableContent .="    <th colspan=\"6\" id=\"table_title\">" . $DataTransferArray[2] . "</th>\n";
   $TableContent .="    </tr>\n";
   $TableContent .="    <tr>\n";
   $TableContent .="      <th class=\"table_header_1\">" . $DataTransferArray[5][0] . "</th>\n";
   $TableContent .="      <th class=\"table_header_2\">" . $DataTransferArray[5][1] . "</th>\n";
   $TableContent .="      <th class=\"table_header_3\">" . $DataTransferArray[5][2] . "</th>\n";
   $TableContent .="      <th class=\"table_header_4\">" . $DataTransferArray[5][3] . "</th>\n";
   $TableContent .="      <th class=\"table_header_5\">" . $DataTransferArray[5][4] . "</th>\n";
   $TableContent .="      <th class=\"table_header_6\">" . $DataTransferArray[5][5] . "</th>\n";
   // Einfuegestelle fuer Zusatzfunktion
   $TableContent .="    </tr>\n";
   $Nr=0;
   $ListDirectoryArrayCount=count($ListDirectoryArray[0]);
   for($y=0; $y < $ListDirectoryArrayCount; $y++) {
      $Nr++;
      $LastSlashPostitionFile=strrpos($ListDirectoryArray[0][$y], '/') + 1;
      $FilenameExtract=substr($ListDirectoryArray[0][$y], $LastSlashPostitionFile);
      $FilenameArrayA=explode(".",$FilenameExtract);
      $FilenameArrayB=explode("_",$FilenameArrayA[0]);
      $FilenameArrayBCount=count($FilenameArrayB);
      if($FilenameArrayBCount > 1) {
         $FileSubject=$FilenameArrayB[0];
         array_shift($FilenameArrayB);
         $FileComment=implode(" ",$FilenameArrayB);
      }
      else
      {
      $FileSubject="";
      $FileComment=$FilenameArrayB[0];
      }
      $MegaByte=1024 * 1024;
      $KiloByte=1024;
      if($ListDirectoryArray[2][$y] > $MegaByte) {
         $SizeValue=$ListDirectoryArray[2][$y] / $MegaByte;
         $FileSize=round($SizeValue,1) . " MB";
      } elseif($ListDirectoryArray[2][$y] > $KiloByte) {
         $SizeValue=$ListDirectoryArray[2][$y] / $KiloByte;
         $FileSize=round($SizeValue,0) . " kB";
      }
      else
      {
      $FileSize=$ListDirectoryArray[2][$y] . " Byte";
      }
      $TableContent .="    <tr>\n";
      $TableContent .="      <td class=\"td_data_left\">" . $Nr . "</td>\n";
      $TableContent .="      <td class=\"td_data_left\">" . $FileSubject . "</td>\n";
      $TableContent .="      <td class=\"td_data_left\">" . $FileComment . "</td>\n";
      $TableContent .="      <td class=\"td_data_left\">" . $ListDirectoryArray[1][$y] . "</td>\n";
      $TableContent .="      <td class=\"td_data_right\">" . $FileSize . "</td>\n";
      $TableContent .="      <td class=\"td_data_center\"><a href=\"" . $ListDirectoryArray[0][$y] . "\">" . $DataTransferArray[5][5] . "</a></td>\n";
      // Einfuegestelle fuer Zusatzfunktion
      $TableContent .="    </tr>\n";
   }
   $TableContent .="    <tr>\n";
   $TableContent .="      <td colspan=\"6\" id=\"table_feet\"><strong>" . $DataTransferArray[3] . "</strong> " . implode(", ", $DirectoryArray) . "</td>\n";
   $TableContent .="    </tr>\n";
   $TableContent .="  </table>\n";
   $TableContent .="<br><br>\n";
   return $TableContent;
}
array_push($data_transfer_array, $startdir, $directory_depth, $table_title_name, $table_feet_name, $file_type_array, $table_colon_name_array);
$list_directory=list_directory($data_transfer_array); // Aufruf und Uebergabe der Daten an die Funktion

// Stylesheet der Tabelle
$css_style = "#table_result {\n  border-collapse: collapse;\n  border-style: none;\n  bgcolor: " . $table_color_array[0] . ";n}\n\n";
$css_style .= "#table_title {\n  padding: 10px 6px 10px 6px;\n  font-size: 16px;  color: " . $table_color_array[2] . ";\n  background-color: " . $table_color_array[1] . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".table_header_1 {\n  width: \"60px\";\n  color: " . $table_color_array[4] . ";\n  background-color: " . $table_color_array[3]  . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".table_header_2 {\n  color: " . $table_color_array[4] . ";\n  background-color: " . $table_color_array[3]  . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".table_header_3 {\n  color: " . $table_color_array[4] . ";\n  background-color: " . $table_color_array[3]  . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".table_header_4 {\n  width: \"130px\";\n  color: " . $table_color_array[4] . ";\n  background-color: " . $table_color_array[3]  . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".table_header_5 {\n  width: \"60px\";\n  color: " . $table_color_array[4] . ";\n  background-color: " . $table_color_array[3]  . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".table_header_6 {\n  width: \"70px\";\n  color: " . $table_color_array[4] . ";\n  background-color: " . $table_color_array[3]  . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".td_data_left {\n  text-align: left;\n  color: " . $table_color_array[6] . ";\n  background-color:" . $table_color_array[5] . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".td_data_right {\n  text-align: right;\n  color: " . $table_color_array[6] . ";\n  background-color:" . $table_color_array[5] . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= ".td_data_center {\n  text-align: center;\n  color: " . $table_color_array[6] . ";\n  background-color:" . $table_color_array[5] . ";\n  border: 1px solid gray;\n}\n\n";
$css_style .= "#table_feet {\n  font-size: 11px;\n  background-color: " . $table_color_array[7] . ";\n  color: " . $table_color_array[8] .";\n  border: 1px solid gray;\n}\n\n";
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Downloadarchiv</title>
<style type="text/css">
body {
 margin: 50px 15px 15px 10px;
}

#div_center {
  display: flex;
  justify-content: center;
  align-content: center;
}

th {
 padding: 6px 6px 6px 6px;
 font-family: Arial, sans-serif;
 font-size: 13px;
 text-align: center;
 font-weight: bold;
}

td {
 padding: 4px 6px 4px 6px;
 font-family: Arial, sans-serif;
 font-size: 13px;
}

<?php echo $css_style; ?>
</style>
</head>
<body>
<div id="div_center">
<?php echo $list_directory; ?>
</div>
</body>
</html>